/*
 * LEDD Project
 * Copyright (C) 2015 LEDD Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.idlegandalf.ledd.components;


import java.util.ArrayList;
import java.util.List;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class LedDDaemon {
    String address;
    int port;
    List<Controller> controllers;
    String version;

    public LedDDaemon(String address, int port) {
        this.address = address;
        this.port = port;
        this.controllers = new ArrayList<>();
    }

    public LedDDaemon() {
        this(null, 0);
    }

    @Override
    public String toString() {
        return address + ":" + port;
    }

    @Override
    public boolean equals(Object o) {
        return o instanceof LedDDaemon && address.equals(((LedDDaemon) o).address) && port == ((LedDDaemon) o).port;
    }

    @Override
    public int hashCode() {
        int result = 23;

        result = 45 * result + port;
        result = 45 * result + address.hashCode();

        return result;
    }
}
