/*
 * LEDD Project
 * Copyright (C) 2015 LEDD Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.idlegandalf.ledd.components;


import com.idlegandalf.ledd.helper.LedDHelper;

import java.util.ArrayList;

public class StripeGroup {
    String mNiceName;
    String mDescription;
    ArrayList<LedStripe> mStripes;

    public String getNiceName() {
        return mNiceName;
    }

    public void setNiceName(String mNiceName) {
        this.mNiceName = mNiceName;
    }

    public String getDescription() {
        return mDescription;
    }

    public void setDescription(String mDescription) {
        this.mDescription = mDescription;
    }

    public LedStripe getStripeByPos(int pos) {
        return mStripes.get(pos);
    }

    public LedStripe getStripeById(int sid) {
        for (int i = 0; i < mStripes.size(); i++) {
            if (mStripes.get(i).getId() == sid) {
                return mStripes.get(i);
            }
        }
        return null;
    }

    public void setRGB(int r, int g, int b, LedDHelper api) {
        for (int i = 0; i < mStripes.size(); i++) {
            //mStripes.get(i).setRGB(r, g, b, api);
        }
    }

    public int addStripe(LedStripe stripe) {
        mStripes.add(stripe);
        return mStripes.size() - 1;
    }

    public void removeStripeByObject(LedStripe stripe) {
        for (int i = 0; i < mStripes.size(); i++) {
            if (mStripes.get(i).getId() == stripe.getId()) {
                mStripes.remove(i);
                return;
            }
        }
    }
}
