/*
 * LEDD Project
 * Copyright (C) 2015 LEDD Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.idlegandalf.ledd.utils;


public class RateLimiter {
    private double rate;
    private double per;
    private double allowance;
    private long last_check;

    public RateLimiter(double rate, double per) {
        this.rate = rate;
        this.per = per;
        this.allowance = rate;
        this.last_check = System.currentTimeMillis();
    }

    public boolean check() {
        long current = System.currentTimeMillis();
        long time_passed = current - last_check;
        last_check = current;
        allowance += time_passed * (rate / per);
        if (allowance > rate) {
            allowance = rate; // throttle
        }

        if (allowance < 1.0) {
            return false;
        } else {
            allowance -= 1.0;
            return true;
        }
    }
}
